###################################################
### chunk number 1:  eval=FALSE
###################################################
## #line 71 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## install.packages("LaplacesDemon")


###################################################
### chunk number 2: 
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
library(LaplacesDemon)


###################################################
### chunk number 3: 
###################################################
#line 84 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
data(demonsnacks)
N <- NROW(demonsnacks)
J <- NCOL(demonsnacks)
y <- log(demonsnacks$Calories)
X <- cbind(1, as.matrix(demonsnacks[,c(1,3:10)]))
for (j in 2:J) {X[,j] <- CenterScale(X[,j])}
mon.names <- c("LP","sigma")
parm.names <- parm.names(list(beta=rep(0,J), log.sigma=0))
MyData <- list(J=J, X=X, mon.names=mon.names, parm.names=parm.names, y=y)


###################################################
### chunk number 4: 
###################################################
#line 117 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Model <- function(parm, Data)
     {
     ### Parameters
     beta <- parm[1:Data$J]
     sigma <- exp(parm[Data$J+1])
     ### Log(Prior Densities)
     beta.prior <- dnorm(beta, 0, sqrt(1000), log=TRUE)
     sigma.prior <- dhalfcauchy(sigma, 25, log=TRUE)
     ### Log-Likelihood
     mu <- tcrossprod(beta, Data$X)
     LL <- sum(dnorm(Data$y, mu, sigma, log=TRUE))
     ### Log-Posterior
     LP <- LL + sum(beta.prior) + sigma.prior
     Modelout <- list(LP=LP, Dev=-2*LL, Monitor=c(LP,sigma), yhat=mu,
          parm=parm)
     return(Modelout)
     }


###################################################
### chunk number 5: 
###################################################
#line 195 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Initial.Values <- c(rep(0,J), log(1))


###################################################
### chunk number 6: 
###################################################
#line 202 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
set.seed(666)


###################################################
### chunk number 7:  eval=FALSE
###################################################
## #line 208 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## help(LaplacesDemon) 


###################################################
### chunk number 8:  eval=FALSE
###################################################
## #line 214 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## Fit <- LaplacesDemon(Model, Data=MyData, Adaptive=900, 
##      Covar=NULL, DR=1, Initial.Values, Iterations=10000,
##      Periodicity=10, Status=1000, Thinning=10)


###################################################
### chunk number 9: 
###################################################
#line 236 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Fit <- LaplacesDemon(Model, Data=MyData, Adaptive=900, 
     Covar=NULL, DR=1, Initial.Values, Iterations=10000,
     Periodicity=10, Status=1000, Thinning=10)


###################################################
### chunk number 10:  eval=FALSE
###################################################
## #line 244 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## str(Fit)


###################################################
### chunk number 11: 
###################################################
#line 250 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Fit$Acceptance.Rate


###################################################
### chunk number 12:  eval=FALSE
###################################################
## #line 257 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## Fit
## print(Fit)


###################################################
### chunk number 13: 
###################################################
#line 264 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Fit


###################################################
### chunk number 14:  eval=FALSE
###################################################
## #line 270 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## Fit$Posterior2


###################################################
### chunk number 15: 
###################################################
#line 282 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Consort(Fit)


###################################################
### chunk number 16: 
###################################################
#line 292 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Rec.Iterations <- trunc(Fit$Rec.Thinning / Fit$Thinning *
     Fit$Iterations)
Status.temp <- round(Rec.Iterations / (Fit$Minutes *
     Rec.Iterations / Fit$Iterations),0)
if(Status.temp < Rec.Iterations) Rec.Status <- Status.temp
#else Rec.Status <- sqrt(Rec.Iterations)


###################################################
### chunk number 17: 
###################################################
#line 303 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Initial.Values <- Fit$Posterior1[Fit$Thinned.Samples,]
Fit <- LaplacesDemon(Model, Data=MyData, Adaptive=0,
     Covar=Fit$Covar, DR=0, Initial.Values, Iterations=290000,
     Periodicity=0, Status=10000, Thinning=290)


###################################################
### chunk number 18: 
###################################################
#line 312 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Consort(Fit)


###################################################
### chunk number 19: 
###################################################
#line 321 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
BurnIn <- Fit$Rec.BurnIn.Thinned


###################################################
### chunk number 20:  eval=FALSE
###################################################
## #line 324 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## plot(Fit, BurnIn, MyData, PDF=FALSE, Parms=Fit$Parameters)


###################################################
### chunk number 21: fig1
###################################################
#line 333 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(3,3))
for (j in 1:3){
     plot(BurnIn:Fit$Thinned.Samples,
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j],
          type="l", xlab="Iterations", ylab="Value",
          main=MyData$parm.names[j])
     panel.smooth(BurnIn:Fit$Thinned.Samples, 
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], pch="")
     plot(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          xlab="Value", main=MyData$parm.names[j])
     polygon(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          col="black", border="black")
     abline(v=0, col="red", lty=2)
     z <- acf(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], plot=FALSE)
     se <- 1/sqrt(length(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]))
     plot(z$lag, z$acf, ylim=c(min(z$acf,-2*se),1), type="h",
          main=MyData$parm.names[j], xlab="Lag", ylab="Correlation")
     abline(h=(2*se), col="red", lty=2)
     abline(h=(-2*se), col="red", lty=2)
     }


###################################################
### chunk number 22: fig2
###################################################
#line 361 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(3,3))
for (j in 4:6){
     plot(BurnIn:Fit$Thinned.Samples,
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j],
          type="l", xlab="Iterations", ylab="Value",
          main=MyData$parm.names[j])
     panel.smooth(BurnIn:Fit$Thinned.Samples, 
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], pch="")
     plot(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          xlab="Value", main=MyData$parm.names[j])
     polygon(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          col="black", border="black")
     abline(v=0, col="red", lty=2)
     z <- acf(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], plot=FALSE)
     se <- 1/sqrt(length(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]))
     plot(z$lag, z$acf, ylim=c(min(z$acf,-2*se),1), type="h",
          main=MyData$parm.names[j], xlab="Lag", ylab="Correlation")
     abline(h=(2*se), col="red", lty=2)
     abline(h=(-2*se), col="red", lty=2)
     }


###################################################
### chunk number 23: fig3
###################################################
#line 389 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(3,3))
for (j in 7:9){
     plot(BurnIn:Fit$Thinned.Samples,
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j],
          type="l", xlab="Iterations", ylab="Value",
          main=MyData$parm.names[j])
     panel.smooth(BurnIn:Fit$Thinned.Samples, 
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], pch="")
     plot(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          xlab="Value", main=MyData$parm.names[j])
     polygon(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          col="black", border="black")
     abline(v=0, col="red", lty=2)
     z <- acf(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], plot=FALSE)
     se <- 1/sqrt(length(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]))
     plot(z$lag, z$acf, ylim=c(min(z$acf,-2*se),1), type="h",
          main=MyData$parm.names[j], xlab="Lag", ylab="Correlation")
     abline(h=(2*se), col="red", lty=2)
     abline(h=(-2*se), col="red", lty=2)
     }


###################################################
### chunk number 24: fig4
###################################################
#line 417 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(3,3))
for (j in 10:11){
     plot(BurnIn:Fit$Thinned.Samples,
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j],
          type="l", xlab="Iterations", ylab="Value",
          main=MyData$parm.names[j])
     panel.smooth(BurnIn:Fit$Thinned.Samples, 
          Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], pch="")
     plot(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          xlab="Value", main=MyData$parm.names[j])
     polygon(density(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]),
          col="black", border="black")
     abline(v=0, col="red", lty=2)
     z <- acf(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j], plot=FALSE)
     se <- 1/sqrt(length(Fit$Posterior1[BurnIn:Fit$Thinned.Samples,j]))
     plot(z$lag, z$acf, ylim=c(min(z$acf,-2*se),1), type="h",
          main=MyData$parm.names[j], xlab="Lag", ylab="Correlation")
     abline(h=(2*se), col="red", lty=2)
     abline(h=(-2*se), col="red", lty=2)
     }
plot(BurnIn:length(Fit$Deviance),
     Fit$Deviance[BurnIn:length(Fit$Deviance)],
     type="l", xlab="Iterations", ylab="Value", main="Deviance")
panel.smooth(BurnIn:length(Fit$Deviance), 
     Fit$Deviance[BurnIn:length(Fit$Deviance)], pch="")
plot(density(Fit$Deviance[BurnIn:length(Fit$Deviance)]),
     xlab="Value", main="Deviance")
polygon(density(Fit$Deviance[BurnIn:length(Fit$Deviance)]),
     col="black", border="black")
abline(v=0, col="red", lty=2)
z <- acf(Fit$Deviance[BurnIn:length(Fit$Deviance)], plot=FALSE)
se <- 1/sqrt(length(Fit$Deviance[BurnIn:length(Fit$Deviance)]))
plot(z$lag, z$acf, ylim=c(min(z$acf,-2*se),1), type="h",
     main="Deviance", xlab="Lag", ylab="Correlation")
abline(h=(2*se), col="red", lty=2)
abline(h=(-2*se), col="red", lty=2)


###################################################
### chunk number 25: fig5
###################################################
#line 461 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(2,3))
JJ <- NCOL(Fit$Monitor); nn <- NROW(Fit$Monitor)
for (j in 1:JJ){
     plot(BurnIn:nn, 
          Fit$Monitor[BurnIn:nn,j],
          type="l", xlab="Iterations", ylab="Value", 
          main=MyData$mon.names[j])
     panel.smooth(BurnIn:nn, 
          Fit$Monitor[BurnIn:nn,j], pch="")
     plot(density(Fit$Monitor[BurnIn:nn,j]), xlab="Value", 
          main=MyData$mon.names[j])
     polygon(density(Fit$Monitor[BurnIn:nn,j]),
          col="black", border="black")
     abline(v=0, col="red", lty=2)
     z <- acf(Fit$Monitor[BurnIn:nn,j], plot=FALSE)
     se <- 1/sqrt(length(Fit$Monitor[BurnIn:nn,j]))
     plot(z$lag, z$acf, ylim=c(min(z$acf,-2*se),1), type="h",
          main=MyData$mon.names[j], xlab="Lag", ylab="Correlation")
     abline(h=(2*se), col="red", lty=2)
     abline(h=(-2*se), col="red", lty=2)
     }


###################################################
### chunk number 26:  eval=FALSE
###################################################
## #line 492 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## caterpillar.plot(Fit, Parms=1:10)


###################################################
### chunk number 27: fig6
###################################################
#line 498 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(1,1))
caterpillar.plot(Fit, Parms=1:10)


###################################################
### chunk number 28: 
###################################################
#line 513 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
Pred <- predict(Fit, Model, MyData)


###################################################
### chunk number 29: 
###################################################
#line 523 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
summary(Pred, Discrep="Chi-Square")


###################################################
### chunk number 30:  eval=FALSE
###################################################
## #line 537 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## plot(Pred, Style="Density", Rows=1:9)


###################################################
### chunk number 31: fig7
###################################################
#line 543 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
par(mfrow=c(3,3))
for (j in 1:9){
     plot(density(Pred$yhat[j,]), xlab="Value",
          main=paste("Post. Pred. Plot of yhat[", j,
               ",]", sep=""), sub="Black=Density, Red=y")
     polygon(density(Pred$yhat[j,]), col="black", border="black")
     abline(v=Pred$y[j], col="red")
     }


###################################################
### chunk number 32:  eval=FALSE
###################################################
## #line 584 "d:/Rcompile/CRANpkg/local/2.12/LaplacesDemon/inst/doc/LaplacesDemon.Stex"
## LaplacesDemon


